config/routes.rb
Hydra::Application.routes.draw do
  namespace :aeon do
    resources :queues do
      collection do
        get 'errors'
        delete 'clear_errors'
      end
    end
    resources :requests do
      member do
        get 'set_to_new'
        get 'set_to_expire'
        get 'set_to_in_process'
        get 'set_to_new'
        get 'set_to_active'
      end
    end
  end

  get 'work_authorizations', to: 'work_authorizations#index', :as => 'work_authorizations'

  resources :audits, :only => [:index, :show]
  resources :pages
  get '/p/:id', to: 'pages#view', :as => 'view_page'

  resources :contact_forms, :only => [:new, :response]
  get 'contact' => 'contact_forms#new'
  get 'contact_response' => 'contact_forms#response'

  mount Qa::Engine => '/qa'

  root :to => "dams_units#index"
  resources :collection, :only => [:show], :controller => 'dams_collections', :as => 'dams_collections' do
    member do
      get 'dams42'
      get 'data'
      get 'ezid'
      get 'ezid_update'
      get 'ezid_batch'
      get 'ezid_batch_update'
      get 'rdf'
      get 'rdf_nt'
      get 'rdf_ttl'
      get 'osf_api'
      get 'osf_push'
      get 'osf_delete'
      get 'osf_data'
    end
  end

  get '/dlp', to: 'dams_units#show', :id => 'dlp'
  get '/rdcp', to: 'dams_units#show', :id => 'rdcp'
  get '/:id/collections', to: 'catalog#collection_search', :as => "dams_unit_collections"
  get '/solrdoc/:id', to: 'catalog#solrdoc', :as => "solrdoc"
  get "collections", :to => 'catalog#collection_search', :as => 'dams_collections'

  Blacklight.add_routes(self, :except => [:solr_document, :catalog]  )

  get 'search/opensearch', :as => "opensearch_catalog"
  get 'search/citation', :as => "citation_catalog"
  get 'search/email', :as => "email_catalog"
  get 'search/sms', :as => "sms_catalog"
  get 'search/endnote', :as => "endnote_catalog"
  get 'search/send_email_record', :as => "send_email_record_catalog"
  get "search/facet/:id", :to => 'catalog#facet', :as => 'catalog_facet'
  get "search", :to => 'catalog#index', :as => 'catalog_index'
  get 'search/:id/librarian_view', :to => "catalog#librarian_view", :as => "librarian_view_catalog"
  resources :solr_document, :path => 'search', :controller => 'catalog', :only => [:show, :update]
  resources :catalog, :only => [:show, :update]

  devise_for :users, skip: [:sessions], :controllers => { :omniauth_callbacks => "users/omniauth_callbacks", :passwords => 'passwords' }

  devise_scope :user do
    get '/users/sign_in', :to => "users/sessions#new", :as => :new_user_session
    get '/users/sign_out', :to => "users/sessions#destroy", :as => :destroy_user_session
    get '/users/auth_link', :to => "users/sessions#new_auth_link", :as => :new_auth_link
    post '/users/auth_link/create', :to => "users/sessions#create_auth_link", :as => :create_auth_link
  end

  resources :dams_subjects, :only => [:show]

  resources :object, :controller => 'dams_objects', :as => 'dams_objects', only: [:index, :show] do
    member do
      get 'dams42'
      get 'data'
      get 'ezid'
      get 'ezid_update'
      get 'rdf'
      get 'rdf_nt'
      get 'rdf_ttl'
    end
  end

  post "object/:id/deriv/:ds", :to => 'file#deriv', :as => 'deriv'
  get "object/:id/zoom/:cmp", :to => 'dams_objects#zoom', :as => 'zoom'

  get "embed/:id/:cmp", :to => 'dams_objects#embed', :as => 'embed'

  get "object/:id/edit", :to => 'dams_objects#edit', :as => 'edit'
  put "object/:id", :to => 'dams_objects#update', :as => 'update'
  get "object/:id/:ds", :to => 'file#show', :constraints => { :ds => /[^\/]+/ }, :as => 'file'
  get "object/:id/:ds/download", :to => 'file#show', defaults: { disposition: 'attachment' }, :constraints => { :ds => /[^\/]+/ }, :as => 'download'
  resources :dams_assembled_collections, only: [:index, :show]
  resources :dams_units, only: [:index, :show] do
    member do
      get 'collections'
    end
  end
  resources :dams_copyrights, only: [:index, :show]
  resources :dams_licenses, only: [:index, :show]
  resources :dams_other_rights, only: [:index, :show]
  resources :dams_statutes, only: [:index, :show]
  resources :dams_languages, only: [:index, :show]
  resources :dams_vocabularies, only: [:index, :show]
  resources :dams_roles, only: [:index, :show]
  resources :dams_provenance_collections, only: [:index, :show]
  resources :dams_provenance_collection_parts, only: [:index, :show]
  resources :dams_vocabulary_entries, only: [:index, :show]
  resources :dams_source_captures, only: [:index, :show]
  resources :dams_cartographics, only: [:index, :show]
  resources :dams_built_work_places, only: [:index, :show]
  resources :dams_iconographies, only: [:index, :show]
  resources :dams_style_periods, only: [:index, :show]
  resources :dams_scientific_names, only: [:index, :show]
  resources :dams_techniques, only: [:index, :show]
  resources :dams_cultures, only: [:index, :show]
  resources :dams_cultural_contexts, only: [:index, :show]
  resources :dams_functions, only: [:index, :show]
  resources :dams_related_resources, only: [:index, :show]
  resources :mads_personal_names, only: [:index, :show]
  resources :mads_family_names, only: [:index, :show]
  resources :mads_corporate_names, only: [:index, :show]
  resources :mads_conference_names, only: [:index, :show]
  resources :mads_complex_subjects, only: [:index, :show]
  resources :mads_topics, only: [:index, :show]
  resources :mads_temporals, only: [:index, :show]
  resources :mads_names, only: [:index, :show]
  resources :mads_occupations, only: [:index, :show]
  resources :mads_genre_forms, only: [:index, :show]
  resources :mads_geographics, only: [:index, :show]
  resources :mads_schemes, only: [:index, :show]
  resources :mads_authority, :as => 'mads_authorities', only: [:index, :show]
  resources :mads_languages, only: [:index, :show]
  resources :dams_lithologies, only: [:index, :show]
  resources :dams_series, only: [:index, :show]
  resources :dams_cruises, only: [:index, :show]
  resources :dams_anatomies, only: [:index, :show]

  resources :get_data do
  get 'get_linked_data', :on => :member
  post 'get_linked_data', :on => :member
  get 'get_name', :on => :member
  post 'get_name', :on => :member
  get 'get_subject', :on => :member
  post 'get_subject', :on => :member
  get 'get_creator', :on => :member
  post 'get_creator', :on => :member
  get 'get_ark', :on => :member
  get 'get_new_objects'
  get 'get_dams_data', :on => :member
  post 'get_dams_data', :on => :member

  end

  get 'collection_options/default_sort' => 'collection_options#default_sort', :as => :collection_sort
  
  resources :random

  get '/ruby-version' => 'application#ruby_version'

end

app/helpers/dams_objects_helper.rb
require "base64"
require "openssl"

module DamsObjectsHelper
  include Dams::ControllerHelper
  #---
    # Openurl, embedded metadata support,
    # Get metadata from solr document, and parsing each field and produce openURL key-encoded value query strings.
    # create mapping from DAMS fields to dublin core fields
    # hweng@ucsd.edu
  #---
  def field_mapping(fieldName)
    data_arr=[]

    fieldData = getFieldData(fieldName)
     if fieldData != nil
      fieldData.each do |value|
        data_arr.push(value)
        end
     end
     data_arr
    end

  def field_mapping_note(note_key, note_type)
    data_arr=[]
    index = getComponentIndex
    fieldData = @document["#{index}note_json_tesim"]

     if fieldData != nil
       fieldData.each do |datum|
        note = JSON.parse(datum)
        if note[note_key] == note_type
          data_arr.push(note['value'])
        end
        end
      end
      data_arr
  end




 def getFieldData(fieldName)
       index = getComponentIndex
       fieldData = @document["#{index}#{fieldName}"]
 end

    def getComponentIndex
        index = (defined?(componentIndex)) ? "component_#{componentIndex}_" : ''
    end

    # Mapping from title_json_tesim, and concatenate as title_json_tesim.value:title_json_tesim.subTitle
    def getTitle
      data_arr=[]

      fieldData=getFieldData('title_json_tesim')
      title_value=''

       if fieldData != nil
         fieldData.each do |datum|
          title = JSON.parse(datum)
          if title['value'] != ''
             title_value = getFullTitle title
             if title['subtitle'] != ''
              title_value=title_value+ title['subtitle']
             end
            data_arr.push(title_value)
          end
        end
       end
        data_arr
    end


    #Need to update
    def getCreator
      data_arr=[]
    end

    def getFormat
       data_arr=[]
    end


    def getDescription
       data_arr = field_mapping_note("type","abstract")
    end

    def getRelation
       data_arr=[]
       fieldData=getFieldData('collection_json_tesim')

       # implementation for relation mapping
    end

    #Need refactor code when MADS implementation is done.
    def getCoverage
       data_arr=[]
    end

    #Need refactor code when MADS implementation is done.
    def getSubject

       fieldValue=field_mapping('subject_tesim')
    end

    def getDate
       data_arr=[]
       index = getComponentIndex
       fieldData = @document["#{index}date_json_tesim"]

       if fieldData != nil
         fieldData.each do |datum|
          date = JSON.parse(datum)
          if date['value'] != ''
            data_arr.push(date['value'])
          end
          end
        end
        data_arr
    end



    def getLanguage
        fieldValue=field_mapping('language_tesim')
    end

    def getIdentifier
       data_arr = field_mapping_note("displayLabel","ARK")
    end

   #dc:publisher
   def getPublisher
      data_arr = field_mapping_note("type","publication")
   end

    def getCopyright
       data_arr=[]
       index = getComponentIndex
     fieldData = @document["#{index}copyright_tesim"]
     if fieldData != nil
      fieldJSON = JSON.parse(fieldData.first)
        temp =fieldJSON['purposeNote']
        temp ='purposeNote: '+temp + ' '+'note: '+fieldJSON['note']
        data_arr.push(temp)
     end
     data_arr
    end

    def getFilesType
      ret = ""
      index = getComponentIndex
      fieldData = @document["#{index}files_tesim"]
      if fieldData != nil
        fieldData.each do |datum|
          files = JSON.parse(datum)
          if files['mimeType'].end_with?("pdf")
            ret = files['formatName']
          end
        end
      end
      ret
    end

   def export_as_openurl
        query_string = []
        query_string << "url_ver=Z39.88-2004&ctx_ver=Z39.88-2004&rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Adc&rfr_id=info%3Asid%2Fblacklight.rubyforge.org%3Agenerator"
        field_map = {
          'title' => getTitle,
          'creator'=>getCreator,
          'subject'=>getSubject,
          'description'=>getDescription,
          'date'=>getDate,
          'format'=>getFormat,
          'language'=> getLanguage,
          'identifier'=>getIdentifier,
          #'coverage'=>getCoverage,
           'publisher'=>getPublisher,
           'rights'=> getCopyright

        }
        field_map.each do |kev, values|
          next if values.empty? or values.first.nil?
          values.each do |value|
            query_string << "rft.#{kev}=#{CGI::escape(value)}"
          end
        end
        query_string.join('&') unless query_string.blank?
    end

  #--
  # End of openURL implementation
  #



  #---
  # select_file: Select files to display
  #---
  def select_file( params )
    document  = params[:document]
    component = params[:component]
    max_size  = params[:quality]
    type      = params[:type]

    prefix = (component != nil) ? "component_#{component}_" : ""
    files = document["#{prefix}files_tesim"]

    # identify acceptable files
    service_use = nil
    service_dim = 0
    service_json = nil
    display_dim  = 0
    display_json = nil
    if files != nil
      files.each{ |f|
        fjson = JSON.parse(f)
        fid = fjson["id"]
        use = fjson["use"]
        if use != nil
          use = use.first
        end
        qual = fjson["quality"]
        if qual != nil
          qualArr = qual.split("x")
          file_dim = qualArr.max { |a,b| a.to_i <=> b.to_i }.to_i
        end
        if type == nil || use.start_with?(type)
          if use != nil && use.end_with?("-service")
            if (service_json == nil || service_use.start_with?("image-") )
              service_json = fjson
              service_use = use
              service_dim = file_dim.to_i
            end
          elsif max_size == nil || file_dim == nil || file_dim.to_i < max_size
            if (display_json == nil || file_dim.to_i > display_dim) && use != nil && (not use.end_with?("-source") )
              display_json = fjson
              display_dim  = file_dim.to_i
            end
          end
        end
      }
    end

    # build file metadata hash
    info = Hash.new
    if ( service_json != nil )
      info[:service] = service_json
    end
    if ( display_json != nil )
      info[:display] = display_json
    end
    info
  end

  def render_file (params)
    component = params[:component]
    quality = params[:quality]

    if component=="0"
      files = select_file( :document=>@document, :quality=>quality )
    else
      files = select_file( :document=>@document, :component=>component, :quality=>quality )
    end
  end

  #---
  # render_file_use
  #---
  def render_file_use( params )
    files = render_file (params)

    file_info = files[:service]
    if file_info != nil
      use = file_info['use'].first
    end
  end

  #---
  # render_service_file
  #---
  def render_service_file( params )
    files = render_file (params)

    service_file = files[:service]
    if service_file != nil
      services=service_file["id"]
    end
  end

  #---
  # render_display_file
  #---
  def render_display_file( params )
    files = render_file (params)

    if files.has_key?(:display)
      display_file = files[:display]
      display=display_file["id"]
    else
      service_file = files[:service]
      if service_file != nil
        services=service_file["id"]

        #---
        # todo: replace no_display with appreciate icons"
        #--
        if services.include?('mp3')
          display = "no_display"
        elsif services.include?('tar.gz')||services.include?('tar')||services.include?('zip')||services.include?('xml')
          display = "no_display"
        end
      end
    end
    display
  end

	#---
	# POST SOLR UPDATE REWRITES
	#---

	#---
	# Get the display file id value from the component's 'files_tesim' value. Replaces 'render_display_file'.
	#
	# @param quality (Optional) The quality of the display file. Possible values: 'icon', 'thumbnail', 'preview' (Default), 'large' and 'huge'
	# @param componentIndex (Optional) The component's index.
	# @return If found, returns a string that is the component's display file id value, otherwise returns 'no_display'
	# @author David T.
	#---
	def grabDisplayFile(parameters={})

		p = {:componentIndex=>nil,:quality=>'preview'}.merge(parameters)
		componentIndex = p[:componentIndex]
		validQualities = Set.new ['icon', 'thumbnail', 'preview', 'large', 'huge']
		quality = (validQualities.include? p[:quality].downcase) ? p[:quality].downcase : 'preview'

		prefix = (componentIndex != nil) ? "component_#{componentIndex}_" : ''
		fieldData = @document["#{prefix}files_tesim"]
		result = 'no_display'

		if fieldData != nil
			fieldData.each do |datum|
				files = JSON.parse(datum)
				if files["use"].end_with?("-#{quality}")
					result = files["id"]
					break
				end
			end
		end

		return result
	end

    def grabAnyDisplayFile
      file = grabDisplayFile
      component_count = @document[:component_count_isi] || 0
      i = 0
      while file == 'no_display' && i < component_count do
        i = i + 1
	    file = grabDisplayFile(componentIndex: i)
        file = "#{i}_#{file}" if file != 'no_display'
      end
      return file
    end

	#---
	# Get the service file id value from the component's 'files_tesim' value. Replaces 'render_service_file'.
	#
	# @param componentIndex (Optional) The component's index.
	# @return A string that is the component's file id value
	# @author David T., hweng
	#---

  def rdcp_image_service_file?(fileUse, unitCode)
    fileUse.end_with?("image-service") && unitCode == Rails.configuration.rdcp_unit_code
  end

 def required_file_use?(param)
   (param.end_with?("document-service")||param.end_with?("video-service")||param.end_with?("audio-service"))
 end

 def file_use(parameters, types)
   fieldData = file_data(parameters)
    result = nil

    if fieldData != nil

app/views/dams_objects/_admin_download.html.erb
<%
	component_id = (defined?(cmpID)) ? "#{cmpID}" : nil
	embed_url = (defined?(embedURL)) ? "#{embedURL}" : nil
	etc_menu_item_class = 'pull-right'
	embed_glyph =  '<i class="glyphicon glyphicon-share-alt"></i> Embed'.html_safe
	adl_glyph =  '<i class="glyphicon glyphicon-download-alt"></i> Download file'.html_safe
  file_format = (defined?(format)) ? "#{format.capitalize}" : ''
  embed_width = (format == 'audio') ? '629' : '560'
  embed_height = (format == 'audio') ? '46' : '315'
  file_size = (format == 'image') ? grabFileSize(:componentIndex=>component_id) : nil
  if file_size
    dim = file_size.split("x")
    embed_width = dim[0]
    embed_height = dim[1]
  end
%>


<% if !vrr_user? %>
  <div class="etc-menu">

    <%= link_to embed_glyph, "#embedLink-#{component_id}", class:etc_menu_item_class, role:'button', :data => { :toggle => 'modal' }, title:'Embed' %>

    <% if can?(:update, @document) || publicSourceDownload && !downloadFilePath.nil? && can_download?(@document, downloadFilePath.split('/').last) then %>
      <%= link_to adl_glyph, downloadFilePath, :rel => 'nofollow', class:etc_menu_item_class, title:'Download file' %>
    <% elsif can?(:read, @document) && can_download?(@document) && !downloadDerivativePath.nil?%>
      <%= link_to adl_glyph, downloadDerivativePath, :rel => 'nofollow', class:etc_menu_item_class, title:'Download file' %>
    <% end %>
 </div>

  <!-- BEGIN_EMBED_MODAL -->
  <div id="embedLink-<%=component_id%>" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="embedLinkLabel" aria-hidden="true">
    <div class="modal-header">
      <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
      <h3 id="embedLinkLabel">Embed</h3>
    </div>
    <div class="modal-body">
      <h4>Embed URL</h4>
      <input class="embedCode" readonly="readonly" type="text" onclick="this.focus();this.select()" value="<%=embed_url%>">
      <h4>Embed <%= file_format %></h4>
      <textarea class="embedCode" readonly="readonly" rows="2" wrap="hard" onclick="this.focus();this.select()">&lt;iframe src="<%=embed_url%>" width="<%= embed_width%>" height="<%= embed_height%>" frameborder="0"&gt;&lt;/iframe&gt;</textarea>
    </div>
    <div class="modal-footer">
      <button class="btn" data-dismiss="modal" aria-hidden="true">Close</button>
    </div>
  </div>
  <!-- /END_EMBED_MODAL -->
<% end %>

app/views/dams_objects/_audio_viewer.html.erb
<%
   prefix = (defined?(componentIndex)) ? "component_#{componentIndex}_" : ''
   objid = @document['id']
   cmpid = (defined?(componentIndex)) ? "#{componentIndex}" : '0'
   fieldData = @document["#{prefix}files_tesim"]
   wowzaURL = grabWowzaURL(fieldData,objid,cmpid)
   embed_url = "#{root_url}embed/#{objid}/#{cmpid}"
   file_type = grabFileType(grabFileUse)
%>
<% if wowzaURL != nil %>
  <div id="dams-audio">Loading the player...</div>

  <script type="text/javascript">
	  jwplayer("dams-audio").setup({
		  playlist:
				  [{
					  sources:
							  [
								  {file: "https://<%=wowzaURL%>/playlist.m3u8"}
							  ]
				  }],
		  width: "100%",
		  height: 40,
		  rtmp: {bufferlength: 3},
		  analytics: {enabled: false}
	  });
    jwplayer().on('ready', function() {
      resize('dams-audio');
      window.onresize = function() {
        resize('dams-audio');
      };    
    });
  </script>

<% end %>
<%= render :partial => 'admin_download', :locals => {:downloadFilePath => downloadFilePath, :embedURL => embed_url, :downloadDerivativePath => downloadDerivativePath, :format => file_type, :publicSourceDownload => publicSourceDownload  } %>

app/views/dams_objects/_component_pager.html.erb
<div id="component-pager">
	<span id="component-pager-label">Component</span>
	<nav class="btn-group pull-right">
	  <button id="component-pager-back" aria-label="Previous Component" class="btn btn-inverse btn-mini"><i aria-hidden="true" class="glyphicon glyphicon-arrow-left"></i></button>
	  <button id="component-pager-forward" aria-label="Next Component" class="btn btn-inverse btn-mini"><i aria-hidden="true" class="glyphicon glyphicon-arrow-right"></i></button>
	</nav>
</div>

app/views/dams_objects/_default_viewer.html.erb
<div class="form-actions dams-download-button">
	<%# <p class="muted"> %>
		<%# <small> %>
			<%# if objectType == 'simple' %>
				<%# There are no files associated with this object. %>
			<%# elsif objectType == 'complex' %>
				<%# There are no files associated with this component. %>
			<%# else %>
				<%# There are no files associated with this object or component. %>
			<%# end %>
		<%# </small> %>
	<%# </p> %>
</div>

app/views/dams_objects/_edit_button.html.erb
<a class="btn btn-small btn-primary" target="edit-form" href="<%= rdf_edit_url (@document['id'])%>">
  <i class="icon-edit icon-white"></i>Edit
</a>


app/views/dams_objects/_metadata_component.html.erb
<% if defined?(componentIndex) %>

	<div class="file-metadata">
		<table class="table">
			<tbody>

				<%# File data %>
				<% if defined?(fileMetadata) and defined?(fileName) %>
					<% if fileMetadata == true %>
						<%= render :partial => 'shared/fields/file_size', :locals => {:componentIndex => componentIndex} %>
						<%= render :partial => 'shared/fields/file_format', :locals => {:componentIndex => componentIndex, :fileName => fileName} %>
					<% end %>
				<% end %>

				<%= render :partial => 'shared/fields/show_raw', :locals => {:componentIndex => componentIndex} %>
								
			</tbody>
		</table>
	</div>

<% end %>

app/views/dams_objects/_object_viewer.html.erb
<div class="row-fluid">
	<section class="span12">
		<% if @document['id'] != nil %>
			<% if @document['component_count_isi'] != nil %>

				<%# COMPLEX OBJECTS %>
				<%= render :partial => 'complex_object_viewer' %>

			<% else %>

				<%# SIMPLE OBJECTS %>
				<%
					ark = render_document_show_field_value(:document=>@document, :field=>'id')
					fileType = grabFileUse
					display_file = grabDisplayFile
					service_file = grabServiceFile
					source_file = grabSourceFile
					pdf_file = grabPDFFile
					display_file_path = (display_file != 'no_display') ? file_path(ark,"_#{display_file}") : ''
					service_file_path = (service_file != nil) ? download_path(ark,"_#{service_file}") : ''
                    if source_file != nil
					  download_file_path = download_path(ark,"_#{source_file}")
					  source_file_path = download_path(ark,"_#{source_file}")
                    elsif service_file != nil
					  download_file_path = download_path(ark,"_#{service_file}")
                    elsif display_file != nil
					  download_file_path = download_path(ark,"_#{display_file}")
                    else
                      download_file_path = ''
                    end
                    
                    if service_file != nil
					  download_derivative_path = download_path(ark,"_#{service_file}")
					end
					
					pdf_file_path = (pdf_file != nil) ? download_path(ark, "_#{pdf_file}") : ''
					zoom_file_path = zoom_path @document['id'], '0'

                    can_public_download = can_public_source_download?(@document)
				%>
				<%= render :partial => 'simple_object_viewer',
							:locals =>
							{
								:fileType => fileType,
								:display_file_path => display_file_path,
								:service_file_path => service_file_path,
								:download_file_path => download_file_path,
								:download_derivative_path => download_derivative_path,
								:source_file_path => source_file_path,
								:service_file => service_file,
								:pdf_file_path => pdf_file_path,
								:zoom_file_path => zoom_file_path,
								:publicSourceDownload => can_public_download
							}
				%>

			<% end %>
		<% end %>
	</section>
</div>

app/views/dams_objects/_pdf_viewer.html.erb
	<div class="well dams-download-button">
		<a class="btn btn-large btn-block btn-primary" href="<%= source %>" target="_blank" rel="nofollow">
			<i class="icon-download-alt icon-white"></i>
			Download PDF
		</a>
	</div>


app/views/dams_objects/_prev_next.html.erb
<% if @previous_document || @next_document %>

  <div class="row-fluid">
    <div class="span12">
	  <div class="search-results-pager">		  
		    <%#= render_constraints(session[:search]) %>
		    <%
		      curr = session[:search][:counter].to_i
		      total = session[:search][:total].to_i
		      prev_item = curr - 1
		      next_item = curr + 1

			    users_search_term = session[:search][:q]
			    bonus_text = "<span>for <abbr title='#{users_search_term}'>%s</abbr></span>"

			    if users_search_term != nil
				    users_search_term = (users_search_term.length > 16) ? "#{users_search_term[0...15]}..." : users_search_term
						bonus_text %= users_search_term
					else
					  bonus_text = ''
			    end
		     %>
		     
		    <% if prev_item > 0 %>
		      <%= link_to_document @previous_document, :label => '<i class="icon-backward"></i> <span>Previous</span>'.html_safe, :counter => prev_item, :force_label => true %>
		    <% end %>
		    <span><%= item_page_entry_info %> <%= link_to "results", session[:search_results], :class => "results_link"%> <%= bonus_text.html_safe %></span>
		    <% if next_item <= total %>
		      <%= link_to_document @next_document, :label => '<span>Next</span> <i class="icon-forward"></i>'.html_safe, :counter => next_item, :force_label => true %>
		    <% end %>
	  </div>
    </div>
  </div>

<% end %>

app/views/dams_objects/_social_links.html.erb
<div class="addthis_sharing_toolbox"></div>
<script type="text/javascript" src="//s7.addthis.com/js/300/addthis_widget.js#pubid=ra-5410cb884082ddc1"></script>

app/views/dams_objects/_text_viewer.html.erb
<%= render :partial => 'admin_download', :locals => {:embedURL => embedURL, :downloadFilePath => downloadFilePath, :downloadDerivativePath => downloadDerivativePath, :format => format, :publicSourceDownload => publicSourceDownload  } %>

app/views/dams_objects/zoom.html.erb
<%
  @page_title =  "Object | #{grabTitle}"
  @cmp = params['cmp']
  files_key = (@cmp != '0') ? "component_#{@cmp}_files_tesim" : "files_tesim"
  @files = @document[files_key] || []
  @files.each do |f|
    json = JSON.parse(f)
    use = json['use']
    @file_id = json['id']
    #image-source and image-service master files
    if use == 'image-source' || use == 'document-service' || (!json['id'].blank? && json['id'].start_with?("1.") && use == 'image-service')
      @quality = json['quality']
      #When quality property not presented,set to image-huge for now?
      if @quality.blank?
        @quality = "1600x1600"
      end
      break
    end
  end
  if @quality.blank? %>
  <p>Error: unable to find zoomable image.</p>
<%
  else
    dim = @quality.split("x")
    p1 = @object[0,2]
    p2 = @object[2,2]
    dir = p1 + "/" + p2 + "/" + @object
    dir += "-#{@cmp}" if @cmp != '0'

    # round image dimensions up to multiple of 256
    width = 256; width *= 2 while width < dim[0].to_i
    height = 256; height *= 2 while height < dim[1].to_i
%>
  <style type="text/css">
    html, body, #map {
      width: 100%; height: 100%; padding: 0; margin: 0;
    }
  </style>
  <div id="map"></div>
  <script type="text/javascript">
    var map = L.map('map').setView(new L.LatLng(0,0), 0);
    L.tileLayer.zoomify('<%=Rails.configuration.zoomify_baseurl%><%=dir%>/', { 
      width: <%=width%>, height: <%=height%>
    }).addTo(map);
  </script>
<% end %>